/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreJumplistRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreJumplist extends TableImpl<VCoreJumplistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_jumplist</code>
     */
    public static final VCoreJumplist V_CORE_JUMPLIST = new VCoreJumplist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreJumplistRecord> getRecordType() {
        return VCoreJumplistRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_jumplist.fk_element</code>.
     */
    public final TableField<VCoreJumplistRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_jumplist.jumplist</code>.
     */
    public final TableField<VCoreJumplistRecord, String> JUMPLIST = createField(DSL.name("jumplist"), SQLDataType.CLOB, this, "");

    private VCoreJumplist(Name alias, Table<VCoreJumplistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreJumplist(Name alias, Table<VCoreJumplistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_jumplist" as  SELECT v.key_variable AS fk_element,
          string_agg(to_char(mc.num_missingcode, '99999'::text), ','::text) AS jumplist
         FROM ((((common_dd.t_core_variable v
           LEFT JOIN common_dd.t_core_missingvalue mv ON ((mv.fk_missinglist = v.fk_missinglist)))
           LEFT JOIN common_dd.t_core_missingmaster mm ON ((mm.pk = mv.fk_missingmaster)))
           LEFT JOIN common_dd.t_dm_missingvalue dmv ON ((dmv.fk_core_missingvalue = mv.pk)))
           LEFT JOIN common_dd.t_dm_missingcode mc ON ((mc.pk = dmv.fk_missingcode)))
        WHERE (mm.reproducible = true)
        GROUP BY v.key_variable;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_jumplist</code> table reference
     */
    public VCoreJumplist(String alias) {
        this(DSL.name(alias), V_CORE_JUMPLIST);
    }

    /**
     * Create an aliased <code>common_dd.v_core_jumplist</code> table reference
     */
    public VCoreJumplist(Name alias) {
        this(alias, V_CORE_JUMPLIST);
    }

    /**
     * Create a <code>common_dd.v_core_jumplist</code> table reference
     */
    public VCoreJumplist() {
        this(DSL.name("v_core_jumplist"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreJumplist as(String alias) {
        return new VCoreJumplist(DSL.name(alias), this);
    }

    @Override
    public VCoreJumplist as(Name alias) {
        return new VCoreJumplist(alias, this);
    }

    @Override
    public VCoreJumplist as(Table<?> alias) {
        return new VCoreJumplist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreJumplist rename(String name) {
        return new VCoreJumplist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreJumplist rename(Name name) {
        return new VCoreJumplist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreJumplist rename(Table<?> name) {
        return new VCoreJumplist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreJumplist where(Condition condition) {
        return new VCoreJumplist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreJumplist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreJumplist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreJumplist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreJumplist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreJumplist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreJumplist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreJumplist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreJumplist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreJumplist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
